/* Mdulo de seleccin de accin.
   Alejandra Barrera
   Versin: 1 (Febrero, 2005)
*/


import nslj.src.system.*; 
import nslj.src.cmd.*; 
import nslj.src.lang.*; 
import nslj.src.math.*; 
import nslj.src.display.*; 
import java.lang.*;
import java.util.*;

public class ActionSelectionSchema extends NslModule
{
	public NslDinInt0 AngleToGo;
	public NslDinInt0 headAngleRat;
	public NslDoutDouble0 changeXRat;
	public NslDoutDouble0 changeYRat;
        public NslDoutDouble0 changeZRat;
	public NslDoutInt0 newHeadAngleRat;
	public NslDoutInt0 ActionTaken;
	public NslDoutInt0 currentDir;
	public NslDoutInt0 nextDir;
	private double ad[]; 
	private int dirToGo;
	private int dirToGoDegrees;
	private int nSteps;
	private double x;
	private double y;
        private double z;
	private int j;
	private int ActionTakenAux;
        private static int activeMapNode;
        private static int activeDirToReinforce;
        private static int nodeToReinforce;
        private static double reinforceAmountPos;
        private static double reinforceAmountNeg;
        private static int stepsToReinforce;
        
	public ActionSelectionSchema (String nslName, NslModule nslParent)
	{
		super(nslName, nslParent);
		AngleToGo= new NslDinInt0("AngleToGo",this);
		headAngleRat= new NslDinInt0("headAngleRat",this);
		changeXRat= new NslDoutDouble0("changeXRat",this);
		changeYRat= new NslDoutDouble0("changeYRat",this);
                changeZRat= new NslDoutDouble0("changeZRat",this);
		newHeadAngleRat= new NslDoutInt0("newHeadAngleRat",this);
		ActionTaken= new NslDoutInt0("ActionTaken",this);
		currentDir= new NslDoutInt0("currentDir",this);
		nextDir= new NslDoutInt0("nextDir",this);
		ad= new double[3];
                activeMapNode= -1;
                activeDirToReinforce= -1;
                reinforceAmountNeg= 71.999999999999999978D;
                reinforceAmountPos= 9.999999999999999978D;
                stepsToReinforce= 1;
	}

    public void computeDirectionToGo(int Angle, int j)
    {
    	for (int i=0; i<3; i++)
    		ad[i]= -1.0;
        if(Angle <= 15 && Angle >= 12)
            ad[0] = (j + 4) % 8;
        else
        if(Angle <= 11 && Angle >= 9)
            ad[0] = (j + 3) % 8;
        else
        if(Angle <= 8 && Angle >= 6)
            ad[0] = (j + 2) % 8;
        else
        if(Angle <= 5 && Angle >= 3)
            ad[0] = (j + 1) % 8;
        else
        if(Angle <= 2 && Angle >= -2)
            ad[0] = j;
        else
        if(Angle <= -3 && Angle >= -5)
            ad[0] = (j + 7) % 8;
        else
        if(Angle <= -6 && Angle >= -8)
            ad[0] = (j + 6) % 8;
        else
        if(Angle <= -9 && Angle >= -11)
            ad[0] = (j + 5) % 8;
        else
        if(Angle <= -12 && Angle >= -15)
            ad[0] = (j + 4) % 8;
        ad[1] = 1.0D;
    }

	public void computeActionTaken()
	{
		dirToGo = (int)ad[0];
        nSteps = (int)ad[1];
        if(dirToGo != -1)
        {
            int i = j - dirToGo;
            ActionTakenAux = (i + 4) % 8;
            if(ActionTakenAux < 0)
                ActionTakenAux += 8;
        } else
        {
            ActionTakenAux = -1;
        }	
	}
	
	public void computeAdjustmentPosition()
	{
		switch(dirToGo)
		{
			case 0:
				x= 0.1;
				y= 0.0;
                                z= 0.0;
				break;
			case 1:
				x= 0.1;
				y= 0.0;
                                z= -0.1;
				break;
			case 2:
				x= 0.0;
				y= 0.0;
                                z= -0.1;
				break;
			case 3:
				x= -0.1;
				y= 0.0;
                                z= -0.1;
				break;
			case 4:
				x= -0.1;
				y= 0.0;
                                z= 0.0;
				break;
			case 5:
				x= -0.1;
				y= 0.0;
                                z= 0.1;
				break;
			case 6:
				x= 0.0;
				y= 0.0;
                                z= 0.1;
				break;
			case 7:
				x= 0.1;
				y= 0.0;
                                z= 0.1;
				break;
			default:
				x= 0.0;
				y= 0.0;
                                z= 0.0;
				break;
		}
	}

    public int beginingReturn(boolean foodPlace, boolean diffAff)
    {
        ListIterator mapIterator;
        NodeMap mapNode= null;
        int dirInt= -1, maxNodeID= -1, maxEdgeDir= -1, maxSteps= 1;
        mapIterator= WorldGraphLayer.map_list.listIterator();
        boolean arcFound= false;
        double currentW= 0D, maxW= 0D;
        while (mapIterator.hasNext() && !arcFound)
        {
            mapNode = (NodeMap)mapIterator.next();
            for(int i = 0; i < mapNode.pointerWGtoWG.size(); i++)
            {
               	Edge edge = (Edge)mapNode.pointerWGtoWG.get(i);
                if(edge.points_to_node == activeMapNode && edge.trace)
                {
                    arcFound= true;
                    edge.trace= false;
                    if (foodPlace && !diffAff)
                    {
                        dirInt= -2;
                        activeMapNode= mapNode.id;
                    }
                    else
                    {
                      currentW= mapNode.w[1][edge.direction];
                          maxW= currentW;
                          maxNodeID= mapNode.id;
                          maxEdgeDir= edge.direction;
                          maxSteps= edge.steps;
                    }
                    i = mapNode.pointerWGtoWG.size();
                 }
             }
        }
        if (arcFound)
        {
            activeDirToReinforce= maxEdgeDir;
            nodeToReinforce= maxNodeID;
            stepsToReinforce= maxSteps;
          dirInt= maxEdgeDir + 4;                    
            if (dirInt > 7)
            dirInt= dirInt - 8;
            
        }
        return dirInt;        
    }

    public int readingMap()
    {
        ListIterator mapIterator;
        NodeMap mapNode= null;
        mapIterator= WorldGraphLayer.map_list.listIterator();
        boolean nodeFound= false;


        while (mapIterator.hasNext() && !nodeFound)
        {
            mapNode = (NodeMap)mapIterator.next();
            if (mapNode.id == nodeToReinforce)
            {
                    activeMapNode= mapNode.id;
                    nodeFound= true;
                    if (Rat.reinforcePath)
                    {
                        reinforceAmountPos= reinforceAmountPos/stepsToReinforce;
                        mapNode.e[1][activeDirToReinforce] += reinforceAmountPos;
                       if (reinforceAmountPos >= 0.009999999999999978D)
                          reinforceAmountPos-= 0.009999999999999978D;
                    }
                    else
                    {
                        reinforceAmountNeg= reinforceAmountNeg/stepsToReinforce;
                        mapNode.e[1][activeDirToReinforce] -= reinforceAmountNeg;
	                if (reinforceAmountNeg >= 0.009999999999999978D)
                        reinforceAmountNeg-= 0.009999999999999978D;
                    }
                     
            }
        }
        int dirInt= -1, maxEdgeDir= -1, maxNodeID= -1, maxSteps=1;
        double currentW= 0D, maxW= 0D;
        boolean arcFound;
        mapIterator= WorldGraphLayer.map_list.listIterator();
        if (nodeFound)
        {
            arcFound= false;
            while (activeMapNode!= 0 && mapIterator.hasNext() && !arcFound)
            {
                mapNode = (NodeMap)mapIterator.next();
                for(int i = 0; i < mapNode.pointerWGtoWG.size(); i++)
                {
                    Edge edge = (Edge)mapNode.pointerWGtoWG.get(i);
                    if(edge.points_to_node == activeMapNode && edge.trace)
                    {
                      edge.trace= false;  
                      arcFound= true;
                      currentW= mapNode.w[1][edge.direction];
                          maxW= currentW;
                          maxNodeID= mapNode.id;
                          maxEdgeDir= edge.direction;
                          maxSteps= edge.steps;
                      i = mapNode.pointerWGtoWG.size();
                    }
                }
            }
            if (arcFound)
            {
                activeDirToReinforce= maxEdgeDir;
                nodeToReinforce= maxNodeID;
                stepsToReinforce= maxSteps;
                dirInt= maxEdgeDir;
            }
        }
        return dirInt;
    }
    
    public void simRun()
	{
		switch(headAngleRat.get())
		{
			default:
				break;
			case 0:
				j=0;
				break;
			case 45:
				j=1;
				break;				
			case 90:
				j=2;
				break;				
			case 135:
				j=3;
				break;
			case 180:
				j=4;
				break;
			case 225:
				j=5;
				break;
			case 270:
				j=6;
				break;
			case 315:
				j=7;
				break;
		}
                
            if (Rat.returning)
            {
                if (WorldGraphLayer.CurrentWGNode != -1)
                    activeMapNode= WorldGraphLayer.CurrentWGNode;
                else
                    activeMapNode= WorldGraphLayer.FromWGNode;
              int dir = beginingReturn(Drive.ateFood, AffPerceptualSchema.differentAff);
              if (dir == -2)
                  dir = beginingReturn(false, AffPerceptualSchema.differentAff);
              dir= readingMap();
              while (dir != -1){
                     dir= readingMap();
              }
                      Rat.returning= false;
                      Rat.reinforcePath= false;
                      reinforceAmountPos= 9.999999999999999978D;
                      reinforceAmountNeg= 71.999999999999999978D;
                      World.trainingTrialNumber = 1;
                      ad[0]= 2; 
                      ad[1]= 1.0; 
                      computeActionTaken();
                      x=0.0;
                      y=0.0;
                      z=0.0;    
                      Rat.newTrial= true;
            }
            else 
            {
                if (Rat.nextTraining) {
                        World.trainingTrialNumber = 1;
                        ad[0]= 2;
                        ad[1]= 1.0;
                        computeActionTaken();
                        x=0.0;
                        y=0.0;
                        z=0.0;    
                        Rat.newTrial= true;
                        Rat.habituation= false;
                        Rat.training= true;
                        Rat.nextTraining= false;
                }
                else if (Rat.nextTesting)
                {
                        World.testingTrialNumber++;
                        switch(World.testingTrialNumber)
                        {
                            case 1:
                            case 2:
                                ad[0]= 2;
                                break;
                            case 3:
                                ad[0]= 0;
                                break;
                            case 4:
                                ad[0]= 6;
                                break;
                        }
                        ad[1]= 1.0;
                        computeActionTaken();
                        x=0.0;
                        y=0.0;
                        z=0.0;    
                        Rat.newTrial= true;
                        Rat.training= false;
                        Rat.testing= true;
                        Rat.nextTesting= false;
                }
                else 
                {
                    if (Rat.newTrial)
                        Rat.newTrial= false;
                    computeDirectionToGo(AngleToGo.get(), j);
                    computeActionTaken();
                    if (dirToGo == j)
			computeAdjustmentPosition();
                    else
                    {
			x=0.0;
			y=0.0;
                        z=0.0;
                    }
                }
            }
		switch(dirToGo)
		{
			default:
				break;
			case 0:
				dirToGoDegrees=0;
				break;
			case 1:
				dirToGoDegrees=45;
				break;				
			case 2:
				dirToGoDegrees=90;
				break;				
			case 3:
				dirToGoDegrees=135;
				break;
			case 4:
				dirToGoDegrees=180;
				break;
			case 5:
				dirToGoDegrees=225;
				break;
			case 6:
				dirToGoDegrees=270;
				break;
			case 7:
				dirToGoDegrees=315;
				break;
		}
		newHeadAngleRat.set(dirToGoDegrees);		
		changeXRat.set(x);		
		changeYRat.set(y);
                changeZRat.set(z);
		ActionTaken.set(ActionTakenAux);
		currentDir.set(j);
		nextDir.set(dirToGo);                    
	} //simRun	
}	
