/* Mdulo NSL que representa la necesidad de comer de la rata.
   Alejandra Barrera
   Versin: 1
   Fecha: 11 de febrero de 2005
*/


import nslj.src.system.*; 
import nslj.src.cmd.*; 
import nslj.src.lang.*; 
import nslj.src.math.*; 
import nslj.src.display.*; 
import java.lang.*;

public class Drive extends NslModule
{

	public NslDinDouble0 distFood; 
	public NslDoutDouble0 driveValue;
	public NslDoutDouble0 reward;
	private double value;
	private double oldValue;
	private double alpha;
	private double max;
	private double min;
	private double reduction;
	private double incentive;
	private double rewardValue;
	private final double OKEEFE_RESOURCE_REDUCTION=0.20000000000000001D;
	private final double OKEEFE_RESOURCE_INCENTIVE=0.14999999999999999D;
	private double dFoodAux;
	private boolean inicio;
	public static boolean ateFood;
		
	public Drive (String nslName, NslModule nslParent)
	{
		super(nslName, nslParent);
		distFood= new NslDinDouble0("distFood",this);
		driveValue= new NslDoutDouble0("driveValue",this);
		reward= new NslDoutDouble0("reward",this);
		inicio= true;
		ateFood= false;
		dFoodAux= -1D;
		value= 0D;
		oldValue= 0D;
		alpha= 0.0030D;
		max= 20.100000000000001D;
		min= 0D;
		reduction= 0D;
		incentive= 0D;
		rewardValue= 0D;
	}

	public void computeDrive(double dFood)
	{
		ateFood= false;
		
		reduction= 0D;
		incentive= 0D;
		if (dFood>= 0D && dFood<1D)
		{
			reduction= OKEEFE_RESOURCE_REDUCTION;
			ateFood= true;
		}
		if (dFood!= -1D)
			incentive= OKEEFE_RESOURCE_INCENTIVE;		
		oldValue= value;
		if (reduction > 0D)
			incentive= 0D;
		double d1 = max - value;
        double d2;
        if(d1 > value)
        	d2 = value;
        else
            d2 = d1;
        value = ((value + alpha * d1) - reduction * value) + incentive * d1;
   		rewardValue = (oldValue / max) * OKEEFE_RESOURCE_REDUCTION;   		
    }
	
	public void simRun()
	{
        	if (!inicio)
			dFoodAux= distFood.get();
		else
			inicio= false;
		computeDrive(dFoodAux);		
		driveValue.set(value);
		reward.set(rewardValue);
	} //simRun
}	
