/* Clase que representa un nodo del mapa topolgico del
   ambiente.
   Alejandra Barrera
   Fecha de creacin: abril 7, 2005.
*/

import java.awt.Color;
import java.awt.Graphics;
import java.util.LinkedList;

public class NodeMap
{
    public int id;
    public int wg_x;
    public int wg_y;
    public LinkedList pointerWGtoWG;
    double w[][];
    double e[][];

    public NodeMap(int i)
    {
        pointerWGtoWG = new LinkedList();
        w = new double[4][8];
        e = new double[4][8];
        id = i;
        wg_x = 0;
        wg_y = 0;
        for(int j = 0; j < 4; j++)
        {
            for(int k = 0; k < 8; k++)
            {
                w[j][k] = 0.0D;
                e[j][k] = 0.0D;
            }
        }
    }
    public void add_edge(int i, int j, int k, int l, int i1, boolean tr)
    {
        pointerWGtoWG.add(new Edge(i, j, k, l, i1, tr));
    }

    public void draw(Graphics g, int i, int j, boolean flag, Color color, boolean flag1)
    {
        g.setColor(color);
        g.fillOval(i, j, 20, 20);
        g.setColor(Color.black);
        g.drawOval(i, j, 20, 20);
        if(flag1)
        {
            g.setColor(Color.black);
            g.drawLine(i + 2, j + 2, i + 18, j + 18);
            g.drawLine(i + 2, j + 18, i + 18, j + 2);
        }
    }    
}