/* Mdulo NSL que representa la funcionalidad de la rata simulada.
   Alejandra Barrera
   Versin 5: 23 de marzo de 2005.
*/


import nslj.src.system.*; 
import nslj.src.cmd.*; 
import nslj.src.lang.*; 
import nslj.src.math.*; 
import nslj.src.display.*; 
import java.lang.*;
import java.util.Random;
import java.io.*;


public class Rat extends NslModule
{
    public NslDinInt0 headAngleRat;
    public NslDinInt2 colorMatrixO;
    public NslDinInt2 colorMatrixR;
    public NslDinInt2 colorMatrixL;
    public NslDoutInt0 cyanO; 
    public NslDoutInt0 yellowO; 
    public NslDoutInt0 blueO; 
    public NslDoutInt0 redO; 
    public NslDoutInt0 roseO; 
    public NslDoutInt0 whiteO; 
    public NslDoutInt0 cyanR; 
    public NslDoutInt0 yellowR; 
    public NslDoutInt0 blueR; 
    public NslDoutInt0 redR; 
    public NslDoutInt0 roseR; 
    public NslDoutInt0 whiteR;
    public NslDoutInt0 cyanL; 
    public NslDoutInt0 yellowL; 
    public NslDoutInt0 blueL; 
    public NslDoutInt0 redL; 
    public NslDoutInt0 roseL; 
    public NslDoutInt0 whiteL; 
    public NslDoutInt0 currentHeadAngleRat;  
    public NslDoutDouble0 distFood; 
    public NslDoutInt0 turnToFood; 
    public NslDoutDouble1 distLandmarks;
    public NslDoutInt1 angleLandmarks;
    private int dim1;
    private int dim2;
    private int angleAux;
    private double distFoodAux;
    private int turnToFoodAux;
    private double distLandmarksAux[];
    private int angleLandmarksAux[];
    private int colorMatrixOAux[][];
    private int colorMatrixRAux[][];
    private int colorMatrixLAux[][];
    public static boolean nextReturn;
    public static boolean beginReturn;
    public static boolean returning;
    public static int totalTrials;
    public static boolean habituation;
    public static boolean training;
    public static boolean testing;
    public static int leftTrials;
    public static int rightTrials;
    public static boolean newTrial;
    public static boolean atRight;
    public static boolean atLeft;
    public static boolean reinforcePath;
    public static boolean nextTesting;
    public static boolean nextTraining;  
    public static int totalTrainingTrials;

    public Rat(String nslName, NslModule nslParent, int d1, int d2)
    {
	super(nslName, nslParent);
	dim1= d1;
	dim2= d2;
        totalTrials= 0;
         totalTrainingTrials= 0;
        habituation= true;
	training= false;
	testing= false;
        nextTraining= false;
        nextTesting= false;
	leftTrials= 0;
	rightTrials= 0;
	newTrial= false;
        nextReturn= false;
        reinforcePath= false;
        beginReturn= false;
        returning= false;
        atRight= false;
        atLeft= false;
        headAngleRat= new NslDinInt0("headAngleRat",this);
        colorMatrixO= new NslDinInt2("colorMatrixO",this,dim1,dim2);
        colorMatrixR= new NslDinInt2("colorMatrixR",this,dim1,dim2);
        colorMatrixL= new NslDinInt2("colorMatrixL",this,dim1,dim2);
        yellowO= new NslDoutInt0("yellowO",this);
        yellowR= new NslDoutInt0("yellowR",this);
        yellowL= new NslDoutInt0("yellowL",this);
       
        blueO= new NslDoutInt0("blueO",this);
        blueR= new NslDoutInt0("blueR",this);
        blueL= new NslDoutInt0("blueL",this);
        
        redO= new NslDoutInt0("redO",this);
        redR= new NslDoutInt0("redR",this);
        redL= new NslDoutInt0("redL",this);
        
        roseO= new NslDoutInt0("roseO",this);
        roseR= new NslDoutInt0("roseR",this);
        roseL= new NslDoutInt0("roseL",this);
        
        whiteO= new NslDoutInt0("whiteO",this);
        whiteR= new NslDoutInt0("whiteR",this);
        whiteL= new NslDoutInt0("whiteL",this);
        
        cyanO= new NslDoutInt0("cyanO",this);
        cyanR= new NslDoutInt0("cyanR",this);
        cyanL= new NslDoutInt0("cyanL",this);
       
        currentHeadAngleRat= new NslDoutInt0("currentHeadAngleRat",this);
        distFood= new NslDoutDouble0("distFood",this);
	distFoodAux= -1D;
	turnToFood= new NslDoutInt0("turnToFood",this);
	turnToFoodAux= -1;
	distLandmarks= new NslDoutDouble1("distLandmarks",this,4);
	angleLandmarks= new NslDoutInt1("angleLandmarks",this,4);
	distLandmarksAux= new double[4];
	angleLandmarksAux= new int[4];
	colorMatrixOAux= new int[dim1][dim2];
        colorMatrixRAux= new int[dim1][dim2];
        colorMatrixLAux= new int[dim1][dim2];
    }

    public void simRun()
    {
        angleAux= headAngleRat.get();
	colorMatrixOAux= colorMatrixO.get();
        colorMatrixRAux= colorMatrixR.get();
        colorMatrixLAux= colorMatrixL.get();
        
        int cPixelsO=0; //cyan
        int yPixelsO=0; //yellow
        int bPixelsO=0; //blue
        int redPixelsO=0; //red
        int rPixelsO=0; //rose
        int wPixelsO=0; //white
        int cPixelsR=0; //cyan
        int yPixelsR=0; //yellow
        int bPixelsR=0; //blue
        int redPixelsR=0; //red
        int rPixelsR=0; //rose
        int wPixelsR=0; //white
        int cPixelsL=0; //cyan
        int yPixelsL=0; //yellow
        int bPixelsL=0; //blue
        int redPixelsL=0; //red
        int rPixelsL=0; //rose
        int wPixelsL=0; //white
       
        for (int i=0; i<dim1; i++)
            for (int j=0; j<dim2; j++)
            {
         	switch(colorMatrixOAux[i][j])
                {
                    case -1: redPixelsO++; break;
                    case 1: bPixelsO++; break;
                    case 2: cPixelsO++; break;
                    case 3: yPixelsO++; break;
                    case 5: rPixelsO++; break;
                    case 7: wPixelsO++; break;
                }
               	switch(colorMatrixRAux[i][j])
                {
                    case -1: redPixelsR++; break;
                    case 1: bPixelsR++; break;
                    case 2: cPixelsR++; break;
                    case 3: yPixelsR++; break;
                    case 5: rPixelsR++; break;
                    case 7: wPixelsR++; break;
                }
         	switch(colorMatrixLAux[i][j])
                {
                    case -1: redPixelsL++; break;
                    case 1: bPixelsL++; break;
                    case 2: cPixelsL++; break;
                    case 3: yPixelsL++; break;
                    case 5: rPixelsL++; break;
                    case 7: wPixelsL++; break;
                }
            }
        if (angleAux == 0 && bPixelsO > 500)
        {
            leftTrials++;
        }
        if (angleAux == 270 && bPixelsO > 500)
        {
            rightTrials++;
        }
        if (habituation && leftTrials == 1)
        {
            nextTraining= true;
        }
        if (newTrial && !returning)
        {
            totalTrainingTrials++;
        }
        if (training && leftTrials == 20)
	{
            nextTesting= true;
        }

        else if (testing && angleAux == 0 && bPixelsO > 500)
        {
            nextTesting= true;
        }        
        else if (training && bPixelsO>500 && angleAux==0)        
        {
            returning= true;
                reinforcePath= true;
        }
        distFoodAux= -1D;
        turnToFoodAux= -1;
        
        switch(angleAux)
	{
            case 0: 
                if (bPixelsO > 200 && bPixelsO < 500) 
                {
                    turnToFoodAux= 0;
                    distFoodAux= 1D;
                }
                else if (bPixelsO >= 500)
                {
                    turnToFoodAux= -1;
                    distFoodAux= 0D;
                }
               break;
        }
        
        for (int k=0; k<4; k++)
	{
            distLandmarksAux[k]=-1D;
            angleLandmarksAux[k]=-1;
	}
        switch(angleAux)
	{
            case 0:
                if (wPixelsL >= 30 && wPixelsL < 150) 
                {
                    angleLandmarksAux[2]= -90;
                    distLandmarksAux[2]= 6D;
                }
                else if (wPixelsL >= 150 && wPixelsO < 500) 
                {
                    angleLandmarksAux[2]= -90;
                    distLandmarksAux[2]= 1D;
                }
                if (wPixelsR >= 300 && wPixelsR < 400 && bPixelsO > 0) 
                {
                    angleLandmarksAux[2]= 90;
                    distLandmarksAux[2]= 1D;
                }
                if (cPixelsL >= 10 && cPixelsL < 65) 
                {
                    angleLandmarksAux[0]= -90;
                    distLandmarksAux[0]= 11D;
                }
                else if (cPixelsL >= 65 && cPixelsL < 200) 
                {
                    angleLandmarksAux[0]= -90;
                    distLandmarksAux[0]= 6D;
                }
                else if (cPixelsL >= 200 && cPixelsL < 400) 
                {
                    angleLandmarksAux[0]= -90;
                    distLandmarksAux[0]= 2D;
                }                
                else if (cPixelsL >= 500) 
                {
                    angleLandmarksAux[0]= -90;
                    distLandmarksAux[0]= 1D;
                }
                if (yPixelsR >= 20 && yPixelsR < 66) 
                {
                    angleLandmarksAux[3]= 90;
                    distLandmarksAux[3]= 11D;
                }
                else if (yPixelsR >= 66 && yPixelsR < 200) 
                {
                    angleLandmarksAux[3]= 90;
                    distLandmarksAux[3]= 6D;
                }
                else if (yPixelsR >= 200 && yPixelsR < 500) 
                {
                    angleLandmarksAux[3]= 90;
                    distLandmarksAux[3]= 2D;
                }
                else if (yPixelsR >= 500) 
                {
                    angleLandmarksAux[3]= 90;
                    distLandmarksAux[3]= 1D;
                }                
                break;
            case 90: 
                if (cPixelsO >= 10 && cPixelsO < 50) 
                {
                    angleLandmarksAux[0]= 0;
                    distLandmarksAux[0]= 11D;
                }
                else if (cPixelsO >= 50 && cPixelsO < 70) 
                {
                    angleLandmarksAux[0]= 0;
                    distLandmarksAux[0]= 8D;
                }
                else if (cPixelsO >= 70 && cPixelsO < 120) 
                {
                    angleLandmarksAux[0]= 0;
                    distLandmarksAux[0]= 6D;
                }
                else if (cPixelsO >= 120 && cPixelsO < 200) 
                {
                    angleLandmarksAux[0]= 0;
                    distLandmarksAux[0]= 4D;
                }
                else if (cPixelsO >= 200 && cPixelsO < 500) 
                {
                    angleLandmarksAux[0]= 0;
                    distLandmarksAux[0]= 2D;
                }                
                else if (cPixelsO >= 500) 
                {
                    angleLandmarksAux[0]= 0;
                    distLandmarksAux[0]= 1D; 
                }
                if (wPixelsO >= 50 && wPixelsO < 100) 
                {
                    angleLandmarksAux[2]= 0;
                    distLandmarksAux[2]= 6D;
                }
                else if (wPixelsO >= 100 && wPixelsO < 200) 
                {
                    angleLandmarksAux[2]= 0;
                    distLandmarksAux[2]= 4D;
                }
                else if (wPixelsO >= 200 && wPixelsO < 390) 
                {
                    angleLandmarksAux[2]= 0;
                    distLandmarksAux[2]= 2D;
                }                
                else if (wPixelsO >= 390) 
                {
                    angleLandmarksAux[2]= 0;
                    distLandmarksAux[2]= 1D;
                }                
                if (bPixelsL >= 10 && bPixelsL < 90) 
                {
                    angleLandmarksAux[1]= -90;
                    distLandmarksAux[1]= 12D;
                }               
                else if (bPixelsL >= 90 && bPixelsL < 300) 
                {
                    angleLandmarksAux[1]= -90;
                    distLandmarksAux[1]= 6D;
                }
                else if (bPixelsL >= 300 && bPixelsL < 500) 
                {
                    angleLandmarksAux[1]= -90;
                    distLandmarksAux[1]= 2D;
                }
                else if (bPixelsL >= 500) 
                {
                    angleLandmarksAux[1]= -90;
                    distLandmarksAux[1]= 1D;
                }  
               if (wPixelsR >= 10 && wPixelsR < 30) 
                {
                    angleLandmarksAux[2]= 90;
                    distLandmarksAux[2]= 12D;
                }
                else if (wPixelsR >= 100 && wPixelsR < 200) 
                {
                    angleLandmarksAux[2]= 90;
                    distLandmarksAux[2]= 7D;
                }
               break;
            case 180:
                if (bPixelsO >= 10 && bPixelsO < 48)
                {
                    angleLandmarksAux[1]= 0;
                    distLandmarksAux[1]= 12D;
                }
                else if (bPixelsO >= 48 && bPixelsO < 70) 
                {
                    angleLandmarksAux[1]= 0;
                    distLandmarksAux[1]= 8D;
                }
                else if (bPixelsO >= 70 && bPixelsO < 150) 
                {
                    angleLandmarksAux[1]= 0;
                    distLandmarksAux[1]= 6D; 
                }
                else if (bPixelsO >= 150 && bPixelsO < 350) 
                {
                    angleLandmarksAux[1]= 0;
                    distLandmarksAux[1]= 4D; 
                }
                else if (bPixelsO >= 350 && bPixelsO < 500) 
                {
                    angleLandmarksAux[1]= 0;
                    distLandmarksAux[1]= 2D;
                }
                else if (bPixelsO >= 500) 
                {
                    angleLandmarksAux[1]= 0;
                    distLandmarksAux[1]= 1D;
                }
                //
                if (cPixelsR >= 10 && cPixelsR < 50) 
                {
                    angleLandmarksAux[0]= 90;
                    distLandmarksAux[0]= 11D;
                }
                else if (cPixelsR >= 50 && cPixelsR < 200) 
                {
                    angleLandmarksAux[0]= 90;
                    distLandmarksAux[0]= 6D;
                }                
                else if (cPixelsR >= 200 && cPixelsR < 500) 
                {
                    angleLandmarksAux[0]= 90;
                    distLandmarksAux[0]= 2D; 
                }                
                else if (cPixelsR >= 500) 
                {
                    angleLandmarksAux[0]= 90;
                    distLandmarksAux[0]= 1D;
                } 
                //
                if (wPixelsR >= 10 && wPixelsR < 350) 
                {
                    angleLandmarksAux[2]= 90;
                    distLandmarksAux[2]= 6D; 
                }
                else if (wPixelsR >= 350) 
                {
                    angleLandmarksAux[2]= 90;
                    distLandmarksAux[2]= 1D; 
                } 
                //
                if (yPixelsL >= 20 && yPixelsL < 150) 
                {
                    angleLandmarksAux[3]= -90;
                    distLandmarksAux[3]= 11D; 
                }
                else if (yPixelsL >= 150 && yPixelsL < 350) 
                {
                    angleLandmarksAux[3]= -90;
                    distLandmarksAux[3]= 6D;
                }                
                else if (yPixelsL >= 350 && yPixelsL < 500) 
                {
                    angleLandmarksAux[3]= -90;
                    distLandmarksAux[3]= 2D;
                }                
                else if (yPixelsL >= 500) 
                {
                    angleLandmarksAux[3]= -90;
                    distLandmarksAux[3]= 1D;
                }                
                //
                if (wPixelsL >= 300 && wPixelsL < 400) 
                {
                    angleLandmarksAux[2]= -90;
                    distLandmarksAux[2]= 1D; 
                }
                break;
            case 270:
                if (yPixelsO >= 10 && yPixelsO < 80) 
                {
                    angleLandmarksAux[3]= 0;
                    distLandmarksAux[3]= 11D;
                }
                else if (yPixelsO >= 80 && yPixelsO < 150) 
                {
                    angleLandmarksAux[3]= 0;
                    distLandmarksAux[3]= 8D; 
                }
                else if (yPixelsO >= 150 && yPixelsO < 350) 
                {
                    angleLandmarksAux[3]= 0;
                    distLandmarksAux[3]= 6D; 
                }
                else if (yPixelsO >= 350 && yPixelsO < 500) 
                {
                    angleLandmarksAux[3]= 0;
                    distLandmarksAux[3]= 2D;
                }
                else if (yPixelsO >= 500) 
                {
                    angleLandmarksAux[3]= 0;
                    distLandmarksAux[3]= 1D;
                }
                //
                if (bPixelsR >= 10 && bPixelsR < 50) 
                {
                    angleLandmarksAux[1]= 90;
                    distLandmarksAux[1]= 12D;
                }               
                else if (bPixelsR >= 70 && bPixelsR < 300) 
                {
                    angleLandmarksAux[1]= 90;
                    distLandmarksAux[1]= 6D;
                }
                else if (bPixelsR >= 300 && bPixelsR < 500) 
                {
                    angleLandmarksAux[1]= 90;
                    distLandmarksAux[1]= 2D;
                }                
                else if (bPixelsR >= 500) 
                {
                    angleLandmarksAux[1]= 90;
                    distLandmarksAux[1]= 1D;
                }
                //
                if (wPixelsL >= 10 && wPixelsL < 100) 
                {
                    angleLandmarksAux[2]= -90;
                    distLandmarksAux[2]= 12D;
                }               
                else if (wPixelsL >= 100 && wPixelsL < 200) 
                {
                    angleLandmarksAux[2]= -90;
                    distLandmarksAux[2]= 7D;
                }
                break;
            default:
                break;
        }
        cyanO.set(cPixelsO);
        cyanR.set(cPixelsR);
        cyanL.set(cPixelsL);
        yellowO.set(yPixelsO);
        yellowR.set(yPixelsR);
        yellowL.set(yPixelsL);
        blueO.set(bPixelsO);
        blueR.set(bPixelsR);
        blueL.set(bPixelsL);
        redO.set(redPixelsO);
        redR.set(redPixelsR);
        redL.set(redPixelsL);
        roseO.set(rPixelsO);
        roseR.set(rPixelsR);
        roseL.set(rPixelsL);
        whiteO.set(wPixelsO);
        whiteR.set(wPixelsR);
        whiteL.set(wPixelsL);
        currentHeadAngleRat.set(angleAux);
        distLandmarks.set(distLandmarksAux);
	angleLandmarks.set(angleLandmarksAux);
	distFood.set(distFoodAux);
	turnToFood.set(turnToFoodAux);
    } //simRun
}	
