import java.io.File;
import org.w3c.dom.*;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.universe.*;

public class WorldConstructor {
    
    Document doc;
    worldBranchGroup wb1 = new worldBranchGroup();
    worldBranchGroup wb2 = new worldBranchGroup();
    worldBranchGroup wb3 = new worldBranchGroup();
    
    public WorldConstructor(String File) {
        try {
	    DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
	    DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();

	    doc = docBuilder.parse(new File(File));

	    doc.getDocumentElement ().normalize ();

	} catch (SAXParseException err) {
	    System.out.println ("** Parsing error" 
		+ ", line " + err.getLineNumber ()
		+ ", uri " + err.getSystemId ());
	    System.out.println("   " + err.getMessage ());
	} catch (SAXException e) {
	    Exception	x = e.getException ();
	    ((x == null) ? e : x).printStackTrace ();
	} catch (Throwable t) {
	    t.printStackTrace ();
	}
        
        constructGroup();
    }
    
    public void constructGroup() {
        NodeList list, listaux;
        org.w3c.dom.Node node, nodeaux, nodeaux2;
        NamedNodeMap attributes;
        int i;
        
        list = doc.getElementsByTagName("sphere");
        for(i=0; i<list.getLength(); i++) {
            float r, cr, cg, cb, xp, yp, zp;
            
            node = list.item(i);
            attributes = node.getAttributes();
            nodeaux = attributes.getNamedItem("r");
            r = (Float.parseFloat(nodeaux.getNodeValue()));
            
            //color
            nodeaux = attributes.getNamedItem("cr");
            cr = (Float.parseFloat(nodeaux.getNodeValue()));
            nodeaux = attributes.getNamedItem("cg");
            cg = (Float.parseFloat(nodeaux.getNodeValue()));
            nodeaux = attributes.getNamedItem("cb");
            cb = (Float.parseFloat(nodeaux.getNodeValue()));
            
            //position
            nodeaux = attributes.getNamedItem("xp");
            xp = (Float.parseFloat(nodeaux.getNodeValue()));
            nodeaux = attributes.getNamedItem("yp");
            yp = (Float.parseFloat(nodeaux.getNodeValue()));
            nodeaux = attributes.getNamedItem("zp");
            zp = (Float.parseFloat(nodeaux.getNodeValue()));
            
            wb1.addSphere(r, new Color3f(cr, cg, cb), xp, yp, zp, true);
            wb2.addSphere(r, new Color3f(cr, cg, cb), xp, yp, zp, false);
            wb3.addSphere(r, new Color3f(cr, cg, cb), xp, yp, zp, false);
        }
        
        //Cylinders
        list = doc.getElementsByTagName("cylinder");
        for(i=0; i<list.getLength(); i++) {
            float r, h, cr, cg, cb, xp, yp, zp;
            
            node = list.item(i);
            attributes = node.getAttributes();
            
            nodeaux = attributes.getNamedItem("r");
            r = (Float.parseFloat(nodeaux.getNodeValue()));
            nodeaux = attributes.getNamedItem("h");
            h = (Float.parseFloat(nodeaux.getNodeValue()));
            
            //color
            nodeaux = attributes.getNamedItem("cr");
            cr = (Float.parseFloat(nodeaux.getNodeValue()));
            nodeaux = attributes.getNamedItem("cg");
            cg = (Float.parseFloat(nodeaux.getNodeValue()));
            nodeaux = attributes.getNamedItem("cb");
            cb = (Float.parseFloat(nodeaux.getNodeValue()));
            
            //position
            nodeaux = attributes.getNamedItem("xp");
            xp = (Float.parseFloat(nodeaux.getNodeValue()));
            nodeaux = attributes.getNamedItem("yp");
            yp = (Float.parseFloat(nodeaux.getNodeValue()));
            nodeaux = attributes.getNamedItem("zp");
            zp = (Float.parseFloat(nodeaux.getNodeValue()));
            
            wb1.addCylinder(r, h, new Color3f(cr, cg, cb), xp, yp, zp, true);
            wb2.addCylinder(r, h, new Color3f(cr, cg, cb), xp, yp, zp, false);
            wb3.addCylinder(r, h, new Color3f(cr, cg, cb), xp, yp, zp, false);
        }
        
        //Boxes
        list = doc.getElementsByTagName("box");
        for(i=0; i<list.getLength(); i++) {
            float x, y, z, cr, cg, cb, xp, yp, zp;
            
            node = list.item(i);
            attributes = node.getAttributes();
            
            nodeaux = attributes.getNamedItem("x");
            x = (Float.parseFloat(nodeaux.getNodeValue()));
            nodeaux = attributes.getNamedItem("y");
            y = (Float.parseFloat(nodeaux.getNodeValue()));
            nodeaux = attributes.getNamedItem("z");
            z = (Float.parseFloat(nodeaux.getNodeValue()));
            
            //color
            nodeaux = attributes.getNamedItem("cr");
            cr = (Float.parseFloat(nodeaux.getNodeValue()));
            nodeaux = attributes.getNamedItem("cg");
            cg = (Float.parseFloat(nodeaux.getNodeValue()));
            nodeaux = attributes.getNamedItem("cb");
            cb = (Float.parseFloat(nodeaux.getNodeValue()));
            
            //position
            nodeaux = attributes.getNamedItem("xp");
            xp = (Float.parseFloat(nodeaux.getNodeValue()));
            nodeaux = attributes.getNamedItem("yp");
            yp = (Float.parseFloat(nodeaux.getNodeValue()));
            nodeaux = attributes.getNamedItem("zp");
            zp = (Float.parseFloat(nodeaux.getNodeValue()));
            
            wb1.addBox(x, y, z, new Color3f(cr, cg, cb), xp, yp, zp, true);
            wb2.addBox(x, y, z, new Color3f(cr, cg, cb), xp, yp, zp, false);
            wb3.addBox(x, y, z, new Color3f(cr, cg, cb), xp, yp, zp, false);
        }
        
        //floor
        list = doc.getElementsByTagName("floor");
        node = list.item(0);
        attributes = node.getAttributes();
        
        nodeaux = attributes.getNamedItem("r");
        float r = (Float.parseFloat(nodeaux.getNodeValue()));
        //color
        nodeaux = attributes.getNamedItem("cr");
        float cr = (Float.parseFloat(nodeaux.getNodeValue()));
        nodeaux = attributes.getNamedItem("cg");
        float cg = (Float.parseFloat(nodeaux.getNodeValue()));
        nodeaux = attributes.getNamedItem("cb");
        float cb = (Float.parseFloat(nodeaux.getNodeValue()));          
        //position
        nodeaux = attributes.getNamedItem("xp");
        float xp = (Float.parseFloat(nodeaux.getNodeValue()));
        nodeaux = attributes.getNamedItem("yp");
        float yp = (Float.parseFloat(nodeaux.getNodeValue()));
        nodeaux = attributes.getNamedItem("zp");
        float zp = (Float.parseFloat(nodeaux.getNodeValue()));
        
        wb1.addCylinder(r, 0, new Color3f(cr, cg, cb), xp, yp, zp, false);
        wb2.addCylinder(r, 0, new Color3f(cr, cg, cb), xp, yp, zp, false);
        wb3.addCylinder(r, 0, new Color3f(cr, cg, cb), xp, yp, zp, false);
        
        
        //top view
        float x, y, z;
        list = doc.getElementsByTagName("topview");
        node = list.item(0);
        attributes = node.getAttributes();
        nodeaux = attributes.getNamedItem("x");
        x = (Float.parseFloat(nodeaux.getNodeValue()));
        nodeaux = attributes.getNamedItem("y");
        y = (Float.parseFloat(nodeaux.getNodeValue()));
        nodeaux = attributes.getNamedItem("z");
        z = (Float.parseFloat(nodeaux.getNodeValue()));
        wb1.setTopView(new Vector3f(x,y,z));
        wb2.setTopView(new Vector3f(x,y,z));
        wb3.setTopView(new Vector3f(x,y,z));
        
        //thirdview
        list = doc.getElementsByTagName("thirdview");
        node = list.item(0);
        attributes = node.getAttributes();
        nodeaux = attributes.getNamedItem("x");
        x = (Float.parseFloat(nodeaux.getNodeValue()));
        nodeaux = attributes.getNamedItem("y");
        y = (Float.parseFloat(nodeaux.getNodeValue()));
        nodeaux = attributes.getNamedItem("z");
        z = (Float.parseFloat(nodeaux.getNodeValue()));
        wb1.setThirdView(new Vector3f(x,y,z));
        wb2.setThirdView(new Vector3f(x,y,z));
        wb3.setThirdView(new Vector3f(x,y,z));
        
        //robot view
        list = doc.getElementsByTagName("robotview");
        node = list.item(0);
        attributes = node.getAttributes();
        nodeaux = attributes.getNamedItem("x");
        x = (Float.parseFloat(nodeaux.getNodeValue()));
        nodeaux = attributes.getNamedItem("y");
        y = (Float.parseFloat(nodeaux.getNodeValue()));
        nodeaux = attributes.getNamedItem("z");
        z = (Float.parseFloat(nodeaux.getNodeValue()));
        wb1.setRobotView(new Vector3f(x,y,z));
        wb2.setRobotView(new Vector3f(x,y,z));
        wb3.setRobotView(new Vector3f(x,y,z));

        //food
        float rF, hF, crF, cgF, cbF, xF, yF, zF;
        list = doc.getElementsByTagName("food");
        node = list.item(0);
        attributes = node.getAttributes();
        nodeaux = attributes.getNamedItem("r");
        rF = (Float.parseFloat(nodeaux.getNodeValue()));
        nodeaux = attributes.getNamedItem("h");
        hF = (Float.parseFloat(nodeaux.getNodeValue()));
        //color
        nodeaux = attributes.getNamedItem("cr");
            crF = (Float.parseFloat(nodeaux.getNodeValue()));
            nodeaux = attributes.getNamedItem("cg");
            cgF = (Float.parseFloat(nodeaux.getNodeValue()));
            nodeaux = attributes.getNamedItem("cb");
            cbF = (Float.parseFloat(nodeaux.getNodeValue()));
            //position
            nodeaux = attributes.getNamedItem("xp");
            xF = (Float.parseFloat(nodeaux.getNodeValue()));
            nodeaux = attributes.getNamedItem("yp");
            yF = (Float.parseFloat(nodeaux.getNodeValue()));
            nodeaux = attributes.getNamedItem("zp");
            zF = (Float.parseFloat(nodeaux.getNodeValue()));
            
        wb1.addFood(rF, hF, new Color3f(crF, cgF, cbF), xF, yF, zF, true);
        wb2.addFood(rF, hF, new Color3f(crF, cgF, cbF), xF, yF, zF, false);
        wb3.addFood(rF, hF, new Color3f(crF, cgF, cbF), xF, yF, zF, false);
        
        
        addDirectionalLight(new Vector3f(0f, 0f, -5), new Color3f(1f, 1f, 1f));
        addDirectionalLight(new Vector3f(0f, 0f, 5), new Color3f(.5f, .5f, .5f));
        addDirectionalLight(new Vector3f(0f, -5f, -5), new Color3f(.5f, .5f, .5f));
        addDirectionalLight(new Vector3f(0f, 5f, -5), new Color3f(.5f, .5f, .5f));
        addDirectionalLight(new Vector3f(0f, -5f, 5), new Color3f(.5f, .5f, .5f));
        addDirectionalLight(new Vector3f(0f, 5f, 5), new Color3f(.5f, .5f, .5f));
        addDirectionalLight(new Vector3f(0f, -5, 0), new Color3f(1f, 1f, 1f));
    }
    
    public worldBranchGroup getFrontGroup() {
        return wb1;
    }
    
    public worldBranchGroup getTopGroup() {
        return wb2;
    }
    
    public worldBranchGroup getLastGroup() {
        return wb3;
    }
    
    public void addDirectionalLight(Vector3f direction, Color3f color) {
	BoundingSphere bounds = new BoundingSphere();
	bounds.setRadius(1000d);
        BoundingSphere bounds1 = new BoundingSphere();
	bounds1.setRadius(1000d);
        BoundingSphere bounds2 = new BoundingSphere();
	bounds2.setRadius(1000d);

	DirectionalLight lightD = new DirectionalLight(color, direction);
        lightD.setInfluencingBounds(bounds);
        DirectionalLight lightD1 = new DirectionalLight(color, direction);
        lightD1.setInfluencingBounds(bounds1);
        DirectionalLight lightD2 = new DirectionalLight(color, direction);
        lightD2.setInfluencingBounds(bounds2);

        wb1.addChild(lightD);
        wb2.addChild(lightD1);
        wb3.addChild(lightD2);
    }
}
