/*
  Clase que representa el frame en que se desplegar el
  mapa del ambiente.
  Versin 1
  Alejandra Barrera
  Fecha de creacin: abril 8, 2005.
*/

import java.awt.*;
import java.util.*;

public class WorldGraphFrame extends Frame
{
    public WorldGraphFrame()
    {
        setTitle("The World Graph");
    }

    public void paint(Graphics g)
    {
    	ListIterator mapIterator;
    	NodeMap mapNode;
    	
        setBackground(Color.white);
        for(mapIterator= WorldGraphLayer.map_list.listIterator(); mapIterator.hasNext();)
        {
        	mapNode = (NodeMap)mapIterator.next();
            g.setColor(Color.black);
            for(int i = 0; i < mapNode.pointerWGtoWG.size(); i++)
            {
            	Edge edge = (Edge)mapNode.pointerWGtoWG.get(i);
                g.drawLine(mapNode.wg_x + 10, mapNode.wg_y + 10, edge.x + 10, edge.y + 10);
                double d2 = edge.x - mapNode.wg_x;
                double d3 = edge.y - mapNode.wg_y;
                double d1 = (1.0D / Math.sqrt(d2 * d2 + d3 * d3)) * d2;
                double d = (1.0D / Math.sqrt(d2 * d2 + d3 * d3)) * d3;
                int j = (int)((double)(edge.x + 10) - 15D * d1) - 5;
                int k = (int)((double)(edge.y + 10) - 15D * d) - 5;
                g.setColor(Color.blue);
                g.fillOval(j, k, 10, 10);
                g.setColor(Color.black);
                g.drawOval(j, k, 10, 10);
            }
        }
        for(mapIterator= WorldGraphLayer.map_list.listIterator(); mapIterator.hasNext();)
        {
        	mapNode = (NodeMap)mapIterator.next();
            if(mapNode.id == WorldGraphLayer.CurrentWGNode)
            	mapNode.draw(g, mapNode.wg_x, mapNode.wg_y, false, Color.red, true);
            else
                if(mapNode.id == WorldGraphLayer.FromWGNode)
                    mapNode.draw(g, mapNode.wg_x, mapNode.wg_y, false, Color.orange, true);
                else
                    mapNode.draw(g, mapNode.wg_x, mapNode.wg_y, false, Color.green, false);
        }
    }    
}