import javax.media.j3d.Canvas3D;
import java.io.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.image.codec.jpeg.*;
import java.awt.*;
import java.awt.image.BufferedImage;
import javax.swing.*;

import javax.media.j3d.Canvas3D;
import com.sun.j3d.utils.universe.SimpleUniverse;
import javax.media.j3d.BranchGroup;
import javax.media.j3d.DirectionalLight;
import javax.media.j3d.BoundingSphere;
import javax.media.j3d.Appearance;
import javax.media.j3d.Material;
import javax.media.j3d.TransformGroup;

public class robotWorldCanvas extends WorldCanvas {
    
    private int Matrix[][] = new int[80][80];
    
    public robotWorldCanvas(GraphicsConfiguration gc, worldBranchGroup branchGroup) {
	super(gc, branchGroup);
    }
    
    public robotWorldCanvas(GraphicsConfiguration gc) {
	super(gc);
    }
    
    public void postSwap() {
        super.postSwap();
       
        Matrix = new int[80][80];
        int y = 0;
        for(int h=0; h<240; h+=3) {
            int x = 0;
            for(int i=0; i<240; i+=3) {
                int[] p = queryRaster(i, h);
                if (p[0] == 255 && p[1] == 0 && p[2] == 0) //rojo
                    Matrix[x][y] = -1;
                else if (p[0] == 0 && p[1] == 0 && p[2] == 255) //azul
                    Matrix[x][y] = 1;
                else if (p[0] == 255 && p[1] == 255 && p[2] == 0) //amarillo
                     Matrix[x][y] = 3;
                else if (p[0] == 255 && p[1] == 0 && p[2] == 255) //rosa
                     Matrix[x][y] = 5;
                else if (p[0] == 255 && p[1] == 255 && p[2] == 255) //blanco
                     Matrix[x][y] = 7;
                else if (p[0] == 0 && p[1] == 255 && p[2] == 255) //cyan
                     Matrix[x][y] = 2;
                x++;
            }
            y++;
        }
    }
    
    public int[][] getColorMatrix() {
        return Matrix;
    }
    
    private int[] queryRaster(int x, int y){
        int[] q={0,0,0};
        
        return realraster.getPixel(x,y,q);
    }
    
    public void finalise() {
        super.finalise();
        
        TransformGroup viewTrans = simpleU.getViewingPlatform().getViewPlatformTransform();
        Transform3D myTransform3D = new Transform3D();
        myTransform3D.setTranslation(rootBranchGroup.getRobotCameraView());
        viewTrans.setTransform(myTransform3D);
    }
    
    public void moveCamera(double degrees) {
        TransformGroup viewTrans = simpleU.getViewingPlatform().getViewPlatformTransform();
        Transform3D myTransform3D2 = new Transform3D();
        myTransform3D2.rotY(Math.toRadians(degrees));
        
        Transform3D temp = new Transform3D();
        viewTrans.getTransform(temp);
        
        temp.mul(myTransform3D2);
        viewTrans.setTransform(temp);
        
        rootBranchGroup.rotateRobotCamera(degrees);        
    }
    
    
    public void moveCamera(Vector3f vector, float degrees) {
        moveCamera(degrees);
        moveCamera(vector);
    } 
    
    public boolean isCollided() {
        return rootBranchGroup.isCollided();
    }    
}
